chiark / gitweb /
Test suite: Prepare for pipefail in t-git-get-ref
[dgit.git] / tests / lib
index 3c31a29cb11ff689128bb791d563002cf48f9bd3..a0a84dda142143b49901a7549e6638a1331c0d62 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -24,14 +24,14 @@ fi
 cd $tmp
 
 tmp=`pwd`
-export HOME=$tmp
-export DGIT_TEST_DUMMY_DIR=$tmp
+
+t-set-using-tmp
+
 ln -f $troot/ssh ssh
 
 mkdir -p $tmp/gnupg
 cp $troot/gnupg/* $tmp/gnupg
 chmod go-rw $tmp/gnupg/*
-export GNUPGHOME=$tmp/gnupg
 
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
@@ -199,6 +199,10 @@ t-git-dir-check () {
        esac
 }
 
+t-rm-dput-dropping () {
+       rm -f $tmp/${p}_${v}_*.upload
+}
+
 t-dgit () {
        local dgit=${DGIT_TEST-dgit}
        : '
@@ -221,7 +225,7 @@ t-cloned-fetched-good () {
        t-refs-same \
                refs/heads/dgit/sid \
                refs/remotes/dgit/dgit/sid
-       t-refs-notexist dgit/unstable remotes/dgit/dgit/unstable
+       t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
 }
 
 t-output () {
@@ -237,7 +241,11 @@ t-clean-on-branch () {
 
 t-git-get-ref () {
        local ref=$1
-       git show-ref -d $1 | perl -ne '
+       case "$ref" in
+       refs/*) ;;
+       *) fail "t-git-get-ref bad $ref" ;;
+       esac
+       (git show-ref -d $1 || test $? = 1) | perl -ne '
                $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
                END { print "$x\n" if length $x; }
        '
@@ -323,6 +331,35 @@ t-822-field () {
        ' <$file
 }
 
+t-stunt-envvar () {
+       local var=$1
+       local tstunt=$2
+       eval '
+               case "'$var'" in
+               "$tstunt:"*)    ;;
+               *":$tstunt:"*)  ;;
+               *)              '$var'="$tstunt:$'$var'" ;;
+               esac
+       '
+}
+
+t-tstunt () {
+       local tstunt=$tmp/tstunt
+       t-stunt-envvar PATH $tstunt
+       t-stunt-envvar PERLLIB $tstunt
+       local f
+       for f in "$@"; do
+               f="./$f"
+               local d="$tstunt/${f%/*}"
+               mkdir -p $d
+               ln -sf "$troot/tstunt/$f" "$d"/.
+       done
+}
+
+t-tstunt-parsechangelog () {
+       t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
+}
+
 t-ref-dsc-dgit () {
        local dsc=${p}_${v}.dsc
        local val=`t-822-field $tmp/incoming/$dsc Dgit`
@@ -333,8 +370,18 @@ t-ref-dsc-dgit () {
 t-apply-diff () {
        local v1=$1
        local v2=$2
-       (cd $troot/pkg-srcs; debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc) \
-               | patch -p1 -u
+       (cd $troot/pkg-srcs;
+        debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
+        | patch -p1 -u
+}
+
+t-commit () {
+       local msg=$1
+       v=1.$revision
+       dch -v$v --distribution unstable "$1"
+       git add debian/changelog
+       debcommit
+       revision=$(( $revision + 1 ))
 }
 
 t-git-config () {
@@ -343,7 +390,6 @@ t-git-config () {
 
 t-drs () {
        export DGIT_TEST_TROOT=$troot
-       export DGIT_TEST_TMP=$tmp
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
@@ -382,11 +428,15 @@ t-policy-admin () {
        ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
 }
 
+t-policy () {
+       local policyhook=$1
+       ln -sf ${DGIT_INFRA_PFX}$policyhook \
+               $drs_dispatch/policy-hook
+}
+
 t-debpolicy () {
        t-dsd
-
-       ln -sf ${DGIT_INFRA_PFX}dgit-repos-policy-debian \
-               $drs_dispatch/policy-hook
+       t-policy dgit-repos-policy-debian
 
        mkdir $tmp/git
        t-policy-admin create-db